> For a complete page index, fetch https://docs.synthflow.ai/llms.txt. For full documentation content, fetch https://docs.synthflow.ai/llms-full.txt.

# Discover MCP tools

POST https://api.synthflow.ai/v2/workspaces/{workspace_id}/mcp-tools/discover

Discovers available MCP tools across all servers configured for the workspace.

Reference: https://docs.synthflow.ai/api-reference/platform-api/mcp-servers/discover-mcp-tools

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Synthflow APIs
  version: 1.0.0
paths:
  /workspaces/{workspace_id}/mcp-tools/discover:
    post:
      operationId: discover-mcp-tools
      summary: Discover MCP tools
      description: >-
        Discovers available MCP tools across all servers configured for the
        workspace.
      tags:
        - subpackage_mcp
      parameters:
        - name: workspace_id
          in: path
          required: true
          schema:
            type: string
        - name: config_id
          in: query
          description: >-
            Optional MCP config identifier to scope discovery to a single server
            configuration.
          required: false
          schema:
            type: string
        - name: Authorization
          in: header
          description: Bearer authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Discovery results (may include per-server errors)
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DiscoverToolsResponse'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                description: Any type
        '404':
          description: No MCP servers configured for this workspace
          content:
            application/json:
              schema:
                description: Any type
        '500':
          description: Internal error
          content:
            application/json:
              schema:
                description: Any type
servers:
  - url: https://api.synthflow.ai/v2
  - url: https://api.us.synthflow.ai/v2
  - url: https://api.eu.synthflow.ai/v2
components:
  schemas:
    MCPToolDefinition:
      type: object
      properties:
        namespaced_tool:
          type: string
          description: 'Fully qualified tool name: {namespace}__{tool_name}'
        original_tool_name:
          type: string
          description: Tool name as returned by the MCP server
        tool_description:
          type:
            - string
            - 'null'
          description: Description returned by MCP server
        input_schema:
          type:
            - object
            - 'null'
          additionalProperties:
            description: Any type
          description: JSON Schema for the tool's input parameters
      required:
        - namespaced_tool
        - original_tool_name
      description: A tool returned by MCP discovery (enriched with namespace)
      title: MCPToolDefinition
    ServerDiscoveryResult:
      type: object
      properties:
        config_id:
          type: string
          description: Stable ID of the MCP server config entry in Vault
        server_name:
          type: string
          description: Raw serverInfo.name from MCP initialize
        server_title:
          type: string
          description: serverInfo.title with noise words stripped
        server_version:
          type: string
        namespace:
          type: string
          description: Derived namespace used as tool name prefix
        tools:
          type: array
          items:
            $ref: '#/components/schemas/MCPToolDefinition'
        error:
          type: string
          description: Non-empty if this server failed discovery
      required:
        - server_name
        - namespace
        - tools
      title: ServerDiscoveryResult
    DiscoverToolsResponse:
      type: object
      properties:
        servers:
          type: array
          items:
            $ref: '#/components/schemas/ServerDiscoveryResult'
      required:
        - servers
      title: DiscoverToolsResponse
  securitySchemes:
    sec0:
      type: http
      scheme: bearer

```

## SDK Code Examples

```python
import requests

url = "https://api.synthflow.ai/v2/workspaces/1727192238961x413997613917405200/mcp-tools/discover"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.synthflow.ai/v2/workspaces/1727192238961x413997613917405200/mcp-tools/discover"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.synthflow.ai/v2/workspaces/1727192238961x413997613917405200/mcp-tools/discover")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.synthflow.ai/v2/workspaces/1727192238961x413997613917405200/mcp-tools/discover")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.synthflow.ai/v2/workspaces/1727192238961x413997613917405200/mcp-tools/discover");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.synthflow.ai/v2/workspaces/1727192238961x413997613917405200/mcp-tools/discover")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```